<template lang="pug">
.chat-container
  .messages-container
    .message(v-for="msg in messages")
      .left
        img.img(:src="msg.pic")
      .right
        span.name {{ msg.user }}
        span.date {{ msg.date }}
        .msg: p {{ msg.msg }}
  .wraper
    .send-container
        input(v-model="newMsg" @keyup.enter="send")
</template>

<script>

  export default {
    name: 'chat-container',

    data() {
      return {
        newMsg: '',
        chatElement: null
      }
    },

    computed: {
      messages() {
        return this.$store.state.messages
      }
    },

    methods: {
      send() {

        let message = {
          type: "chatMessage",
          data: {
            msg: this.newMsg,
            date: Date(),
            user: this.$store.state.user.name,
            pic: this.$store.state.user.pic,
          }
        }

        this.$socket.send(JSON.stringify(message))
        this.newMsg = ''

      }

    },

    mounted() {

      this.chatElement = document.querySelector(".messages-container")      

      this.$socket.onmessage = (event) => {
        let message = JSON.parse(event.data)

        if (message.type === "chatMessage") {
          this.$store.commit('newMessage', message.data)
        }
      }


    },
    updated() {
      // TODO: Improve the query element
      this.chatElement.scrollTop = this.chatElement.scrollHeight
    }
  }
</script>
